#include <iostream>
#include <bits/stdc++.h>

using namespace std;

long long Stepen(long long x,long long s){
    long long p=1;

    for(int i=0;i<s;i++){
        p*=x;
    }
    return p;
}

int main()
{
    int N,M;
    cin>>N>>M;
    int B[M+1];
    for(int i=1;i<=M;i++){
        cin>>B[i];
    }
    long long C;
    cin>>C;
    long long x=0;
    int A[N+1];
    for(int i=1;i<=N;i++){
        A[i]=i;
    }

    for(int i=0;i<=N-M;i++){
        for(int j=1;j<=M;j++)
        A[i+B[j]]=A[i+j];
    }

    for(int i=1;i<=N;i++){
        x+=(Stepen(C,i))*A[i];
    }
    x=x%998244353;

    cout<<x;
    return 0;
}